﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

[ExecuteInEditMode]
[RequireComponent(typeof(Camera))]
public class ConvolutionEffect : PostEffectsBase {

    [Range(3, 301)]
    public int boxKernelWindowWidth = 3;

    void Start() {
        shader = Shader.Find("NPR/Convolution");
        //shader = Shader.Find("NPR/ConvolutionMultipass");
        CreateMaterial();
    }

    // multipass effect implementation by calling passes separately
    /*void OnRenderImage(RenderTexture source, RenderTexture destination) {
        if (CreateMaterial()) {
            RenderTexture tmp = RenderTexture.GetTemporary(source.width, source.height, 0, RenderTextureFormat.DefaultHDR);
            material.SetInt("boxKernelWidth", boxKernelWindowWidth);
            //Graphics.Blit(source, destination, material);
            Graphics.Blit(source, tmp, material, 0);
            Graphics.Blit(tmp, destination, material, 1);
            tmp.Release();
        }
        else {
            Graphics.Blit(source, destination);
        }
    }*/

    // multipass effect implementation by calling all passes at once (assumes a GrabPass in the shader between passes)
    void OnRenderImage(RenderTexture source, RenderTexture destination) {
        if (CreateMaterial()) {
            material.SetInt("boxKernelWidth", boxKernelWindowWidth);
            Graphics.Blit(source, destination, material);
        }
        else {
            Graphics.Blit(source, destination);
        }
    }
}
