﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

[ExecuteInEditMode]
[RequireComponent(typeof(Camera))]
public class BWEffect : PostEffectsBase
{

    public float luminanceThreshold = 0.5f;
    public bool adaptive = false;

    void Start()
    {
        shader = Shader.Find("NPR/BWShader");
        CreateMaterial();
    }

    void Update()
    {
        if (adaptive) material.EnableKeyword("ADAPTIVE");
        else material.DisableKeyword("ADAPTIVE");
    }

    void OnRenderImage(RenderTexture source, RenderTexture destination)
    {
        if (CreateMaterial())
        {
            material.SetFloat("luminanceThreshold", luminanceThreshold);
            Graphics.Blit(source, destination, material);
        }
        else
        {
            Graphics.Blit(source, destination);
        }
    }
}

