﻿Shader "NPR/Quantization"
{
	Properties
	{
		_MainTex ("Texture", 2D) = "white" {}
	}
	SubShader
	{
		// No culling or depth
		Cull Off ZWrite Off ZTest Always

		Pass
		{
			CGPROGRAM
			#pragma vertex vert
			#pragma fragment frag
			
			#include "UnityCG.cginc"
			#include "../Lab03/colorspaces.cginc"
			struct appdata
			{
				float4 vertex : POSITION;
				float2 uv : TEXCOORD0;
			};

			struct v2f
			{
				float2 uv : TEXCOORD0;
				float4 vertex : SV_POSITION;
			};

			v2f vert (appdata v)
			{
				v2f o;
				o.vertex = UnityObjectToClipPos(v.vertex);
				o.uv = v.uv;
				return o;
			}
			
			sampler2D _MainTex;
			int levels;
			float transitionSharpness;

			float3 frag (v2f i) : SV_Target
			{
				float3 col = tex2D(_MainTex, i.uv).rgb;
				float3 hsv = rgb_to_hsv(col);

				float V = hsv.b  * levels;
				float Vfloor = floor(V);
				float Vfrac = V - Vfloor;
				hsv.b = (Vfloor + smoothstep(Vfloor + transitionSharpness, Vfloor+1, V)) / float(levels);

				col = hsv_to_rgb(hsv);
					
				return float4(col,1);
			}
			ENDCG
		}
	}
}
