﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEditor;

[ExecuteInEditMode]
[RequireComponent(typeof(Camera))]
public class TexturedStrokes : MonoBehaviour {

    Texture3D strokeMap;
    public Vector2 strokeTiling = new Vector2(1, 1);
	// Use this for initialization
	void Start () {
        Camera camera = GetComponent<Camera>();
        Shader shader = Shader.Find("NPR/TexturedStrokes");
        camera.SetReplacementShader(shader, "");

        Texture2D texture2 = (Texture2D)AssetDatabase.LoadAssetAtPath("Assets/Lab06/ST/4_1.jpg", typeof(Texture2D));
        Texture2D texture3 = (Texture2D)AssetDatabase.LoadAssetAtPath("Assets/Lab06/ST/3_1.jpg", typeof(Texture2D));
        Texture2D texture1 = (Texture2D)AssetDatabase.LoadAssetAtPath("Assets/Lab06/ST/5_1.jpg", typeof(Texture2D));
        Texture2D texture4 = (Texture2D)AssetDatabase.LoadAssetAtPath("Assets/Lab06/ST/2_1.jpg", typeof(Texture2D));
        Texture2D texture5 = (Texture2D)AssetDatabase.LoadAssetAtPath("Assets/Lab06/ST/1_1.jpg", typeof(Texture2D));
        strokeMap = new Texture3D(texture1.width, texture1.height, 5, TextureFormat.RGBA32, false);
        int pixelCount = texture1.width * texture1.height;
        Color32[] allPixels = new Color32[pixelCount * 5];

        Color32[] texPixels;
        texPixels = texture1.GetPixels32(0);
        System.Array.Copy(texPixels, 0, allPixels, 0, pixelCount);
        texPixels = texture2.GetPixels32(0);
        System.Array.Copy(texPixels, 0, allPixels, pixelCount, pixelCount);
        texPixels = texture3.GetPixels32(0);
        System.Array.Copy(texPixels, 0, allPixels, 2 * pixelCount, pixelCount);
        texPixels = texture4.GetPixels32(0);
        System.Array.Copy(texPixels, 0, allPixels, 3 * pixelCount, pixelCount);
        texPixels = texture5.GetPixels32(0);
        System.Array.Copy(texPixels, 0, allPixels, 4 * pixelCount, pixelCount);

        strokeMap.SetPixels32(allPixels, 0);
        strokeMap.wrapModeU = TextureWrapMode.Repeat;
        strokeMap.wrapModeV = TextureWrapMode.Repeat;
        strokeMap.wrapModeW = TextureWrapMode.Clamp;
        strokeMap.Apply();

    }

    // Update is called once per frame
    void Update () {
        Shader.SetGlobalTexture("_StrokeMap", strokeMap);
        Shader.SetGlobalVector("textureScale", strokeTiling);
    }
}
