﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

[ExecuteInEditMode]
[RequireComponent(typeof(Camera))]
public class PixelizeManualEffect : PostEffectsBase
{
    [Range(0, 4)]
    public int level = 1;

   void Start () {
        shader = Shader.Find("NPR/PixelizeManualShader");
        CreateMaterial();
    }

   void OnRenderImage(RenderTexture source, RenderTexture destination)
    {
        if (CreateMaterial())
        {
            RenderTexture inTexture = source;
            for (int l = 0; l < level; ++l)
            {
                RenderTexture outTexture = RenderTexture.GetTemporary(inTexture.width / 2, inTexture.height / 2);
                //inTexture.filterMode = FilterMode.Point;
                inTexture.filterMode = FilterMode.Bilinear;
                Graphics.Blit(inTexture, outTexture, material);
                inTexture = outTexture;
            }

            inTexture.filterMode = FilterMode.Point;
            Graphics.Blit(inTexture, destination);
        }
        else
        {
            Graphics.Blit(source, destination);
        }
    }
}
