﻿Shader "NPR/PixelizeManualShader"
{
	Properties
	{
		_MainTex ("Texture", 2D) = "white" {}
	}
	SubShader
	{
		// No culling or depth
		Cull Off ZWrite Off ZTest Always

		Pass
		{
			CGPROGRAM
			#pragma vertex vert
			#pragma fragment frag
			
			#include "UnityCG.cginc"

			struct appdata
			{
				float4 vertex : POSITION;
				float2 uv : TEXCOORD0;
			};

			struct v2f
			{
				float2 uv : TEXCOORD0;
				float4 vertex : SV_POSITION;
			};

			v2f vert (appdata v)
			{
				v2f o;
				o.vertex = UnityObjectToClipPos(v.vertex);
				o.uv = v.uv;
				return o;
			}
			
			sampler2D _MainTex;
			float4 _MainTex_TexelSize;

			float4 frag (v2f i) : SV_Target
			{
				// Use this when bilinear sampling is set on _MainTex
				float4 col = tex2D(_MainTex, i.uv);

				// Use this when point sampling is set on _MainTex
				/*
				float4 col = tex2D(_MainTex, i.uv + float2(-1,-1)*_MainTex_TexelSize.xy / 4);
				col += tex2D(_MainTex, i.uv + float2( 1,-1)*_MainTex_TexelSize.xy / 4);
				col += tex2D(_MainTex, i.uv + float2(-1, 1)*_MainTex_TexelSize.xy / 4);
				col += tex2D(_MainTex, i.uv + float2( 1, 1)*_MainTex_TexelSize.xy / 4);
				col /= 4;
				*/

				return col;
			}

			ENDCG
		}
	}
}
