﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

[ExecuteInEditMode]
[RequireComponent(typeof(Camera))]
public class PixelizeMipmapEffect : PostEffectsBase {

    [Range(0, 4)]
    public int level = 1;

	void Start () {
        shader = Shader.Find("NPR/PixelizeMipmapShader");
        CreateMaterial();
    }

    void OnRenderImage(RenderTexture source, RenderTexture destination) {
        if (CreateMaterial())
        {
            RenderTexture renderTex = RenderTexture.GetTemporary(source.width, source.height);
            renderTex.useMipMap = true;
            Graphics.Blit(source, renderTex); // this generates all mip-maps

            renderTex.filterMode = FilterMode.Point;
            material.SetInt("lodLevel", level);
            Graphics.Blit(renderTex, destination, material);

            RenderTexture.ReleaseTemporary(renderTex);
        }
        else
        {
            Graphics.Blit(source, destination);
        }
    }
}
